﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace stocks
{
    public partial class Form1 : Form
    {
        int _stockPrize = 100;
        int _oldStockPrize = 100;
        int _stockCount = 0;
        int _money = 1000;
        Random _rnd = new Random();
        int[] _graphinfo = new int[40];
        int _graphIndex = 1;
        bool _IsStockGaining = false;
        bool[] _IsStockStill = new bool[10];
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonBuy_Click(object sender, EventArgs e)
        {
            if (_money > _stockPrize)
            {
                _stockCount++;
                _money -= _stockPrize;
                labelStockCount.Text = "Count of stocks: " + _stockCount;
                labelMoney.Text = "Your budget: " + _money + "$";
            }
        }

        private void buttonSell_Click(object sender, EventArgs e)
        {
            if (_stockCount > 0)
            {
                _stockCount--;
                _money += _stockPrize;
                labelMoney.Text = "Your money: " + _money + "$";
                labelStockCount.Text = "Count of stocks: " + _stockCount;
            }
        }

        private void timerStockPrizeChange_Tick(object sender, EventArgs e)
        {
            _stockPrize += _rnd.Next(-10, 11);
            if (_oldStockPrize - _stockPrize == 0)
            {
                _IsStockStill[_graphIndex - 1] = true;
            }
            if (_oldStockPrize - _stockPrize >= 0)
            {
                _graphinfo[_graphIndex * 4 - 3 - 1] = 0; // jestli bude cervena
                _IsStockGaining = false;
            }
            else
            {
                _graphinfo[_graphIndex * 4 - 3 - 1] = 1; // jestli bude zelena
                _IsStockGaining = true;
            }
            if (_IsStockGaining)
            {
                _graphinfo[_graphIndex * 4 - 2 - 1] = 350 + _stockPrize; // souradnice X kdyz stoupa akcie
            }
            else
            {
                _graphinfo[_graphIndex * 4 - 2 - 1] = 350 + (_stockPrize - (_oldStockPrize- _stockPrize)); // souradnice X  kdyz klesa akcie
            }
            
            _graphinfo[_graphIndex * 4 - 1 - 1] = 150 + _graphIndex * 25; // souradnice Y
            if (_IsStockGaining)
            {
                _graphinfo[_graphIndex * 4 - 1] = (_stockPrize - _oldStockPrize); // tloustka kdyz stoupaji
            }
            else
            {
                _graphinfo[_graphIndex * 4 - 1] = (_oldStockPrize - _stockPrize); // tloustka kdyz klesaji
            }

            
            _oldStockPrize = _stockPrize;
            _graphIndex++;
            if (_graphIndex == 11)
            {
                _graphIndex = 1;
                for (int i = 0; i < _graphinfo.Length; i++)
                {
                    _graphinfo[i] = 0;
                }
            }

            // labely
            labelStockPrize.Text = "Prize of stock: " + _stockPrize + "$";
            labelStocksWorth.Text = "Stocks worth: " + _stockPrize * _stockCount + "$";
            labelProfit.Text = "Profit: " + (_money - 1000).ToString() + "$";
            Invalidate();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            for (int i = 0; i < 10; i++)
            {
                if (_IsStockStill[i])
                {
                    g.FillRectangle(Brushes.Yellow, _graphinfo[i * 4 + 1] - 2, _graphinfo[i * 4 + 2], 4, 20);
                }
                else if (_graphinfo[i * 4] == 0)
                {
                    g.FillRectangle(Brushes.Red, _graphinfo[i * 4 + 1], _graphinfo[i * 4 + 2], _graphinfo[ i * 4 + 3], 20);
                }
                else
                {
                    g.FillRectangle(Brushes.Green, _graphinfo[i * 4 + 1], _graphinfo[i * 4 + 2], _graphinfo[i * 4 + 3], 20);
                }
            }
        }
    }
}
